diff --git a/gcc/testsuite/gfortran.dg/goacc/nested-reductions-warn.f90 b/gcc/testsuite/gfortran.dg/goacc/nested-reductions-2-parallel.f90
similarity index 78%
rename from gcc/testsuite/gfortran.dg/goacc/nested-reductions-warn.f90
rename to gcc/testsuite/gfortran.dg/goacc/nested-reductions-2-parallel.f90
index ec36bc9616e..8fa2cabd35f 100644
--- a/gcc/testsuite/gfortran.dg/goacc/nested-reductions-warn.f90
+++ b/gcc/testsuite/gfortran.dg/goacc/nested-reductions-2-parallel.f90
@@ -1,4 +1,6 @@
-! Test erroneous cases of nested reduction loops.
+! Test erroneous cases of nested 'reduction' clauses.
+
+! See also 'c-c++-common/goacc/nested-reductions-2-parallel.c'.
 
 subroutine acc_parallel ()
   implicit none (type, external)
@@ -495,180 +497,3 @@ subroutine acc_parallel_loop_reduction ()
     end do
   end do
 end subroutine acc_parallel_loop_reduction
-
-! The same tests as above, but inside a routine construct.
-subroutine acc_routine ()
-  implicit none (type, external)
-  !$acc routine gang
-  integer :: i, j, k, l, sum, diff
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
-      do j = 1, 10
-        !$acc loop reduction(+:sum)
-        do k = 1, 10
-          sum = 1
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop collapse(2)  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
-      do j = 1, 10
-        do k = 1, 10
-          !$acc loop reduction(+:sum)
-          do l = 1, 10
-            sum = 1
-          end do
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
-      do j = 1, 10
-        !$acc loop  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
-        ! { dg-warning "insufficient partitioning available to parallelize loop" "" { target *-*-* } .-1 }
-        do k = 1, 10
-          !$acc loop reduction(+:sum)
-          do l = 1, 10
-            sum = 1
-          end do
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop reduction(-:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
-      do j = 1, 10
-        !$acc loop reduction(+:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
-        do k = 1, 10
-          sum = 1
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop reduction(-:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
-      do j = 1, 10
-        !$acc loop reduction(-:sum)
-        do k = 1, 10
-          sum = 1
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop reduction(-:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
-      do j = 1, 10
-        !$acc loop  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
-        ! { dg-warning "insufficient partitioning available to parallelize loop" "" { target *-*-* } .-1 }
-        do k = 1, 10
-          !$acc loop reduction(*:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
-          do l = 1, 10
-            sum = 1
-          end do
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop reduction(-:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
-      do j = 1, 10
-        !$acc loop reduction(+:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
-        ! { dg-warning "insufficient partitioning available to parallelize loop" "" { target *-*-* } .-1 }
-        do k = 1, 10
-          !$acc loop reduction(*:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
-          do l = 1, 10
-            sum = 1
-          end do
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum) reduction(-:diff)
-    do i = 1, 10
-      !$acc loop reduction(-:diff)  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
-      do j = 1, 10
-        !$acc loop reduction(+:sum)
-        do k = 1, 10
-          sum = 1
-        end do
-      end do
-
-      !$acc loop reduction(+:sum)  ! { dg-warning "nested loop in reduction needs reduction clause for .diff." }
-      do j = 1, 10
-        !$acc loop reduction(-:diff)
-        do k = 1, 10
-            diff = 1
-        end do
-      end do
-    end do
-end subroutine acc_routine
-
-subroutine acc_kernels ()
-  integer :: i, j, k, sum, diff
-
-  ! FIXME:  No diagnostics are produced for these loops because reductions
-  ! in kernels regions are not supported yet.
-  !$acc kernels
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      do j = 1, 10
-        do k = 1, 10
-          sum = 1
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop
-      do j = 1, 10
-        do k = 1, 10
-          sum = 1
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop reduction(-:diff)
-      do j = 1, 10
-        !$acc loop
-        do k = 1, 10
-          sum = 1
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop
-      do j = 1, 10
-        !$acc loop reduction(+:sum)
-        do k = 1, 10
-          sum = 1
-        end do
-      end do
-    end do
-
-    !$acc loop reduction(+:sum)
-    do i = 1, 10
-      !$acc loop reduction(-:sum)
-      do j = 1, 10
-        !$acc loop reduction(+:sum)
-        do k = 1, 10
-          sum = 1
-        end do
-      end do
-    end do
-  !$acc end kernels
-end subroutine acc_kernels
diff --git a/gcc/testsuite/gfortran.dg/goacc/nested-reductions-2-routine.f90 b/gcc/testsuite/gfortran.dg/goacc/nested-reductions-2-routine.f90
new file mode 100644
index 00000000000..cc7802ecd10
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/goacc/nested-reductions-2-routine.f90
@@ -0,0 +1,119 @@
+! Test erroneous cases of nested 'reduction' clauses.
+
+! See also 'c-c++-common/goacc/nested-reductions-2-routine.c'.
+
+subroutine acc_routine ()
+  implicit none (type, external)
+  !$acc routine gang
+  integer :: i, j, k, l, sum, diff
+
+    !$acc loop reduction(+:sum)
+    do i = 1, 10
+      !$acc loop  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
+      do j = 1, 10
+        !$acc loop reduction(+:sum)
+        do k = 1, 10
+          sum = 1
+        end do
+      end do
+    end do
+
+    !$acc loop reduction(+:sum)
+    do i = 1, 10
+      !$acc loop collapse(2)  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
+      do j = 1, 10
+        do k = 1, 10
+          !$acc loop reduction(+:sum)
+          do l = 1, 10
+            sum = 1
+          end do
+        end do
+      end do
+    end do
+
+    !$acc loop reduction(+:sum)
+    do i = 1, 10
+      !$acc loop  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
+      do j = 1, 10
+        !$acc loop  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
+        ! { dg-warning "insufficient partitioning available to parallelize loop" "" { target *-*-* } .-1 }
+        do k = 1, 10
+          !$acc loop reduction(+:sum)
+          do l = 1, 10
+            sum = 1
+          end do
+        end do
+      end do
+    end do
+
+    !$acc loop reduction(+:sum)
+    do i = 1, 10
+      !$acc loop reduction(-:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
+      do j = 1, 10
+        !$acc loop reduction(+:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
+        do k = 1, 10
+          sum = 1
+        end do
+      end do
+    end do
+
+    !$acc loop reduction(+:sum)
+    do i = 1, 10
+      !$acc loop reduction(-:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
+      do j = 1, 10
+        !$acc loop reduction(-:sum)
+        do k = 1, 10
+          sum = 1
+        end do
+      end do
+    end do
+
+    !$acc loop reduction(+:sum)
+    do i = 1, 10
+      !$acc loop reduction(-:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
+      do j = 1, 10
+        !$acc loop  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
+        ! { dg-warning "insufficient partitioning available to parallelize loop" "" { target *-*-* } .-1 }
+        do k = 1, 10
+          !$acc loop reduction(*:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
+          do l = 1, 10
+            sum = 1
+          end do
+        end do
+      end do
+    end do
+
+    !$acc loop reduction(+:sum)
+    do i = 1, 10
+      !$acc loop reduction(-:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
+      do j = 1, 10
+        !$acc loop reduction(+:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
+        ! { dg-warning "insufficient partitioning available to parallelize loop" "" { target *-*-* } .-1 }
+        do k = 1, 10
+          !$acc loop reduction(*:sum)  ! { dg-warning "conflicting reduction operations for .sum." }
+          do l = 1, 10
+            sum = 1
+          end do
+        end do
+      end do
+    end do
+
+    !$acc loop reduction(+:sum) reduction(-:diff)
+    do i = 1, 10
+      !$acc loop reduction(-:diff)  ! { dg-warning "nested loop in reduction needs reduction clause for .sum." }
+      do j = 1, 10
+        !$acc loop reduction(+:sum)
+        do k = 1, 10
+          sum = 1
+        end do
+      end do
+
+      !$acc loop reduction(+:sum)  ! { dg-warning "nested loop in reduction needs reduction clause for .diff." }
+      do j = 1, 10
+        !$acc loop reduction(-:diff)
+        do k = 1, 10
+            diff = 1
+        end do
+      end do
+    end do
+end subroutine acc_routine

